#include <windows.h>



int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR lpCmdLine, int nCmdShow)
{
	char *p = lpCmdLine;
	char *args[3];
	int n = 0;
	while(*p) {
		while(*p == ' ')
			p++;
		args[n++] = p;
		if(n == 3)
			break;
		while(*p && *p != ' ')
			p++;
	}
	

	if(n != 3) {
		MessageBox(0, 
			"Prioaff by Adron\n\n"
			"A simple tool to start a process with a given\n"
			"priority and affinity\n\n"
			"Syntax:\n"
			"prioaff <priority> <affinity> <executable> [arguments]\n"
			"priority: 0..3 for idle..realtime\n"
			"affinity: binary process affinity mask\n\n"
			"You are free to use this program as you please.\n"
			"Please drop me a message and let me know\n"
			"if you're making a derived work from it.\n\n"
			"As always, there are no express or implied\n"
			"warranties as to the functionality\n"
			"of this application!", "Prioaff", MB_OK);
		return 1;
	}

	DWORD priorities[4] = {IDLE_PRIORITY_CLASS, NORMAL_PRIORITY_CLASS, HIGH_PRIORITY_CLASS, REALTIME_PRIORITY_CLASS};
	DWORD priority = strtoul(args[0], 0, 10);
	DWORD affinity = strtoul(args[1], 0, 2);
	DWORD processmask, systemmask;
	GetProcessAffinityMask(GetCurrentProcess(), &processmask, &systemmask);

	if(priority > 3) {
		MessageBox(0, "Invalid priority value!", "Prioaff", MB_OK);
		return 1;
	}
	if((affinity & processmask) != affinity) {
		MessageBox(0, "Invalid affinity value!", "Prioaff", MB_OK);
		return 1;
	}

	STARTUPINFO si;
	PROCESS_INFORMATION pi;

	ZeroMemory(&si, sizeof si);
	si.cb = sizeof si;
	si.dwFlags = STARTF_USESHOWWINDOW;
	si.wShowWindow = nCmdShow;

	BOOL success = CreateProcess(0, args[2], 0, 0, 0, CREATE_SUSPENDED | priorities[priority], 0, 0, &si, &pi);
	
	if(!success) {
		char message[128];
		wsprintf(message, "CreateProcess failed, error: %d\n", GetLastError());
		MessageBox(0, message, "Prioaff", MB_OK);
		return 0;
	}

	success = SetProcessAffinityMask(pi.hProcess, affinity);

	if(!success) {
		char message[128];
		wsprintf(message, "SetProcessAffinityMask failed, error: %d\n", GetLastError());
		MessageBox(0, message, "Prioaff", MB_OK);
	}

	ResumeThread(pi.hThread);

	CloseHandle(pi.hProcess);
	CloseHandle(pi.hThread);
	
	return 0;
}
 
